var serverInfo = $api.getStorage('serverInfo');
// alert(JSON.stringify(serverInfo));
accessid = serverInfo.accessid;
accesskey = serverInfo.accesskey;
host = serverInfo.host;


g_dirname = ''
g_object_name = ''
g_object_name_type = ''
now = timestamp = Date.parse(new Date()) / 1000;

var policyText = {
    "expiration": "2020-01-01T12:00:00.000Z", //设置该Policy的失效时间，超过这个失效时间之后，就没有办法通过这个policy上传文件了
    "conditions": [
        ["content-length-range", 0, 1048576000] // 设置上传文件的大小限制
    ]
};

var policyBase64 = Base64.encode(JSON.stringify(policyText))
message = policyBase64
var bytes = Crypto.HMAC(Crypto.SHA1, message, accesskey, { asBytes: true });
var signature = Crypto.util.bytesToBase64(bytes);

function check_object_radio() {
    var tt = document.getElementsByName('myradio');
    for (var i = 0; i < tt.length; i++) {
        if (tt[i].checked) {
            g_object_name_type = tt[i].value;
            break;
        }
    }
}

function get_dirname() {
    dir = document.getElementById("dirname").value;
    if (dir != '' && dir.indexOf('/') != dir.length - 1) {
        dir = dir + '/'
    }
    //alert(dir)
    g_dirname = dir
}

function random_string(len) {
    len = len || 32;
    var chars = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678';
    var maxPos = chars.length;
    var pwd = '';
    for (i = 0; i < len; i++) {
        pwd += chars.charAt(Math.floor(Math.random() * maxPos));
    }
    return pwd;
}

function get_suffix(filename) {
    pos = filename.lastIndexOf('.')
    suffix = ''
    if (pos != -1) {
        suffix = filename.substring(pos)
    }
    return suffix;
}

function calculate_object_name(filename) {
    if (g_object_name_type == 'local_name') {
        g_object_name += "${filename}"
    } else if (g_object_name_type == 'random_name') {
        suffix = get_suffix(filename)
        g_object_name = g_dirname + random_string(10) + suffix
    }
    return ''
}

function get_uploaded_object_name(filename) {
    if (g_object_name_type == 'local_name') {
        tmp_name = g_object_name
        tmp_name = tmp_name.replace("${filename}", filename);
        return tmp_name
    } else if (g_object_name_type == 'random_name') {
        return g_object_name
    }
}

function set_upload_param(up, filename, ret) {
    g_object_name = g_dirname;
    if (filename != '') {
        suffix = get_suffix(filename)
        calculate_object_name(filename)
    }
    new_multipart_params = {
        'key': g_object_name,
        'policy': policyBase64,
        'OSSAccessKeyId': accessid,
        'success_action_status': '200', //让服务端返回200,不然，默认会返回204
        'signature': signature,
    };

    up.setOption({
        'url': host,
        'multipart_params': new_multipart_params
    });

    up.start();
}

var uploader = new plupload.Uploader({
    runtimes: 'html5,flash,silverlight,html4',
    browse_button: 'selectfiles',
    //multi_selection: false,
    filters: {
        mime_types: [ //只允许上传图片
            { title: "Image files", extensions: "jpg,png,jpeg" }
        ],
        // max_file_size: '750kb',
    },
    resize: {
        width: 350,
        quality: 100,
        preserve_headers: true
    },
    container: document.getElementById('container'),
    flash_swf_url: 'lib/plupload-2.1.2/js/Moxie.swf',
    silverlight_xap_url: 'lib/plupload-2.1.2/js/Moxie.xap',
    url: 'http://oss.aliyuncs.com',
    init: {
        PostInit: function() {
            document.getElementById('ossfile').innerHTML = '';
            // document.getElementById('postfiles').onclick = function() {
            //     set_upload_param(uploader, '', false);
            //     return false;
            // };
        },

        FilesAdded: function(up, files) {
            plupload.each(files, function(file) {
                previewImage(file);

            });
        },

        BeforeUpload: function(up, file) {
            check_object_radio();
            get_dirname();
            set_upload_param(up, file.name, true);
        },

        UploadProgress: function(up, file) {

        },

        FileUploaded: function(up, file, info) {
            if (info.status == 200) {
                // document.getElementById(file.id).getElementsByTagName('b')[0].innerHTML = 'upload to oss success, object name:' + get_uploaded_object_name(file.name);
                if ($("#uploadImgList").val()) {
                    $("#uploadImgList").val($("#uploadImgList").val() + '||' + host + get_uploaded_object_name(file.name));
                } else {
                    $("#uploadImgList").val(host + get_uploaded_object_name(file.name));
                }
            } else {
                _alert(info.response, 'middle');
            }
        },

        UploadComplete: function() {
            publishComment();
        },

        Error: function(up, err) {
            switch (err.code) {
                case -600:
                    _alert('文件太大,请重新选择', 'middle');
                    break;
                case -601:
                    _alert('只能选择jpg,png,jpeg图片', 'middle');
                    break;
                default:
                    _alert('错误代码：' + err.code, 'middle');
            }
            // document.getElementById('console').appendChild(document.createTextNode("\nError xml:" + err));
        }
    }
});

uploader.init();


function previewImage(file, callback) { //file为plupload事件监听函数参数中的file对象,callback为预览图片准备完成的回调函数
    if (!file || !/image\//.test(file.type)) return;
    // if (file.type == 'image/gif') { //gif使用FileReader进行预览,因为mOxie.Image只支持jpg和png
    //     var fr = new mOxie.FileReader();
    //     fr.onload = function() {
    //         callback(fr.result);
    //         fr.destroy();
    //         fr = null;
    //     }
    //     fr.readAsDataURL(file.getSource());
    // } else {
    var preloader = new mOxie.Image();
    preloader.onload = function() {
        preloader.downsize(300, 300); //先压缩一下要预览的图片,宽300，高300
        var imgsrc = preloader.type == 'image/jpeg' ? preloader.getAsDataURL('image/jpeg', 80) : preloader.getAsDataURL(); //得到图片src,实质为一个base64编码的数据
        if ($('.uploadimg').length >= 9) {
            _alert('最多选择9张照片', 'middle');
            $("#container").hide();
            return;
        }
        $("#container").before("<img class='uploadimg' src='" + imgsrc + "'>");
        document.getElementById('ossfile').innerHTML += '<div id="' + file.id + '">' + file.name + ' (' + plupload.formatSize(file.size) + ')<b></b>' +
            '<div class="progress"><div class="progress-bar" style="width: 0%"></div></div>' +
            '</div>';
    };
    preloader.load(file.getSource());
    // }
}